/* Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/*
 * String controller
 */
let shareformKey = ""
let nodeIdParams = ""
let exeCount = true
let schemaListObj = {}
window.share && window.share.event.on("editCurrentNodeForm", (params)=> {
    // console.log(params)
    shareformKey = params
})

window.share && window.share.event.on("editCurrentNodeId", (paramsId)=>{
    // console.log(paramsId)
    nodeIdParams = paramsId
})

angular.module('flowableModeler').controller('FlowableStringPropertyCtrl', [ '$scope', function ($scope) {

	$scope.shapeId = $scope.selectedShape.id;
	$scope.valueFlushed = false;
    /** Handler called when input field is blurred */
    $scope.inputBlurred = function() {
    	$scope.valueFlushed = true;
    	if ($scope.property.value) {
    		$scope.property.value = $scope.property.value.replace(/(<([^>]+)>)/ig,"");
    	}
        $scope.updatePropertyInModel($scope.property);
    };

    $scope.enterPressed = function(keyEvent) {
        // if enter is pressed
        if (keyEvent && keyEvent.which === 13) {
            keyEvent.preventDefault();
            $scope.inputBlurred(); // we want to do the same as if the user would blur the input field
        }
        // else; do nothing
    };
    
    $scope.$on('$destroy', function controllerDestroyed() {
    	if(!$scope.valueFlushed) {
    		if ($scope.property.value) {
        		$scope.property.value = $scope.property.value.replace(/(<([^>]+)>)/ig,"");
        	}
    		$scope.updatePropertyInModel($scope.property, $scope.shapeId);
    	}
    });

    // console.log($scope)

}]);

/*
 * Boolean controller
 */

angular.module('flowableModeler').controller('FlowableBooleanPropertyCtrl', ['$scope', function ($scope) {

    $scope.changeValue = function() {
        if ($scope.property.key === 'oryx-defaultflow' && $scope.property.value) {
            var selectedShape = $scope.selectedShape;
            if (selectedShape) {
                var incomingNodes = selectedShape.getIncomingShapes();
                if (incomingNodes && incomingNodes.length > 0) {
                    // get first node, since there can be only one for a sequence flow
                    var rootNode = incomingNodes[0];
                    var flows = rootNode.getOutgoingShapes();
                    if (flows && flows.length > 1) {
                        // in case there are more flows, check if another flow is already defined as default
                        for (var i = 0; i < flows.length; i++) {
                            if (flows[i].resourceId != selectedShape.resourceId) {
                                var defaultFlowProp = flows[i].properties.get('oryx-defaultflow');
                                if (defaultFlowProp) {
                                    flows[i].setProperty('oryx-defaultflow', false, true);
                                }
                            }
                        }
                    }
                }
            }
        }
        $scope.updatePropertyInModel($scope.property);
    };

}]);

/*
 * Text controller
 */

angular.module('flowableModeler').controller('FlowableTextPropertyCtrl', [ '$scope', '$modal', '$timeout', function($scope, $modal, $timeout) {

    var opts = {
        template:  'editor-app/configuration/properties/text-popup.html?version=' + Date.now(),
        scope: $scope,
        prefixEvent: 'textModalEvent'
    };
    
     $scope.$on('textModalEvent.hide.before', function() {
        $timeout(function() {
            $scope.property.mode = 'read';
        }, 0);
    });
    // Open the dialog
    _internalCreateModal(opts, $modal, $scope);
}]);

angular.module('flowableModeler').controller('FlowableTextPropertyPopupCtrl', ['$scope', function($scope) {

    $scope.save = function() {
        $scope.updatePropertyInModel($scope.property);
        $scope.close();
    };
    
    $scope.close = function() {
        $scope.property.mode = 'read';
        $scope.$hide();
    };
}]);

angular.module('flowableModeler').controller('FieldReadConfigPopupCtrl', ['$rootScope','$scope', '$http', function($rootScope, $scope, $http) {

    window.share && window.share.event.on("editCurrentNodeId", (params)=>{
        // console.log(params)
        nodeIdParams = params
    })

    if (nodeIdParams && shareformKey) {
        $http.get(FLOWABLE.APP_URL.GetColumnConfig(nodeIdParams, shareformKey))
        .success((res)=>{
            
            if (res.FieldConfigList && res.FieldConfigList.length > 0) {

                var result = [];
                var obj = {};
                for(var i =0; i<res.FieldConfigList.length; i++){
                    if(!obj[res.FieldConfigList[i].FieldCode]){
                        result.push(res.FieldConfigList[i]);
                        obj[res.FieldConfigList[i].FieldCode] = true;
                    }
                }

                result.forEach((item)=>{
                    $scope.property.properties.forEach((pItem)=>{
                        if (item.FieldCode === pItem.FieldName) {
                            pItem.defaultChecked = item.IsShow === "1" ? true : false
                            pItem.defaultIsRequired = item.IsRequired === "true" ? true : false
                            if (item.IsReadOnly === "true" || item.IsReadOnly === "1") {
                                pItem.defaultIsReadOnly = true
                            } else {
                                pItem.defaultIsReadOnly = false
                            }
                        }
                    })
                })
                schemaListObj = $scope.property

                $scope.childFieldObj = schemaListObj

                // console.log($scope.childFieldObj, "$scope.childFieldObj")

            } else {
                $scope.property.properties.forEach(el => {
                    el.defaultChecked = true
                    el.defaultIsRequired = false
                });
            }
        })
    }

    $scope.isShow = true

    $scope.toggleTable=function() {
        $scope.isShow = !$scope.isShow
    }

    $scope.changeValue = function(params) {
        // console.log(params)
        const data = {
            ActID: $rootScope.currentReadResourceId,
            Config: "",
            FieldCode: params.FieldName,
            FieldName: params.FieldName,
            FieldType: 'string',
            FormKey: shareformKey,
            IsShow: params.defaultChecked ? 1: 0,
            Type: params.defaultValue,
            Unit: params.defaultUnit,
            IsRequired: params.defaultIsRequired,
            IsReadOnly: params.defaultIsReadOnly
        }
        $http({method: 'POST', url: FLOWABLE.APP_URL.SaveFieldConfig(), data: data})
        .success(function(res) {
            // console.log(res)
        })
    }
}]);

angular.module('flowableModeler').controller('FieldWriteConfigPopupCtrl', ['$scope','$modal', '$timeout','$http', function($scope, $modal, $timeout, $http) {

    $scope.toggleTable=function() {
        $scope.isShow = !$scope.isShow
    }

    $scope.changeValue=function() {

    }
}]);

angular.module('flowableModeler').controller('FieldTextPopup', ['$rootScope','$scope', function($rootScope,$scope) {
    $scope.childFieldObj = $rootScope.curField
    // console.log($scope.childFieldObj)
    $scope.save = function() {
        $scope.updatePropertyInModel($scope.property);
        $scope.close();
    };
    
    $scope.close = function() {
        $scope.property.mode = 'read';
        $scope.$hide();
    };

    $scope.changeValue = function() {
        // console.log($scope)
    }
}]);


angular.module('flowableModeler').controller('ExtraFormReadConfig', ['$rootScope','$scope', '$http', function($rootScope, $scope, $http) {
    let componentList = []
    let arr = []
    let chArr = []
    // console.log(nodeIdParams, "nodeIdParams")
    if (nodeIdParams) {
        $http.get(FLOWABLE.APP_URL.GetAssemblyModel(''))
        .success((res)=>{
            res.getMe.forEach((item)=>{
                item.defaultChecked = false
            })
            arr = res.getMe
            $http.get(FLOWABLE.APP_URL.GetAssemblyModel(nodeIdParams))
            .success((response)=>{
                chArr = response.getMe
                arr.forEach((item)=>{
                    chArr.forEach(cItem=>{
                        if (item.AssemblyName === cItem.AssemblyName) {
                            item.defaultChecked = true
                        }
                    })
                })
                componentList = arr

                $scope.componentList = componentList
                // console.log($scope.componentList, '$scope.componentList')
            })
        })
    }
    
    $scope.changeValue = function(params) {
        let OperType = 0
        if (params.defaultChecked) {
            OperType = 1
        }
        $http.get(FLOWABLE.APP_URL.SaveAssemblyConfig(nodeIdParams, params.AssemblyName, OperType))
        .success(res=>{
            // console.log(res)
        })
    }
}]);